<?php

use think\migration\Migrator;
use think\migration\db\Column;
use Phinx\Db\Adapter\MysqlAdapter;

class ControlAlarm extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('control_alarm', ['engine' => 'InnoDB', 'collation' => 'utf8mb4_general_ci', 'comment' => '布控预警' ,'id' => 'id','signed' => true ,'primary_key' => ['id']]);
        $table->addColumn('plate_no', 'string', ['limit' => 32,'null' => true,'signed' => true,'comment' => '车牌',])
			->addColumn('rfid_sn', 'string', ['limit' => 32,'null' => true,'signed' => true,'comment' => '车辆标签',])
			->addColumn('address', 'string', ['limit' => 255,'null' => true,'signed' => true,'comment' => '报警地点',])
			->addColumn('alarm_type', 'string', ['limit' => 16,'null' => true,'signed' => true,'comment' => '报警类型',])
			->addColumn('state', 'string', ['limit' => 8,'null' => true,'signed' => true,'comment' => '状态',])
			->addColumn('remark', 'string', ['limit' => 255,'null' => true,'signed' => true,'comment' => '备注',])
			->addColumn('creator_id', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '创建人ID',])
			->addColumn('created_at', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '创建时间',])
			->addColumn('updated_at', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '更新时间',])
			->addColumn('deleted_at', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '软删除',])
            ->create();
    }
}
