<?php

use think\migration\Migrator;
use think\migration\db\Column;
use Phinx\Db\Adapter\MysqlAdapter;

class LocationLog extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('location_log', ['engine' => 'InnoDB',  'comment' => '' ,'id' => 'id','signed' => true ,'primary_key' => ['id']]);
        $table->addColumn('longitude', 'decimal', ['precision' => 10,'scale' => 0,'null' => true,'signed' => true,'comment' => '经度',])
			->addColumn('latitude', 'decimal', ['precision' => 10,'scale' => 0,'null' => true,'signed' => true,'comment' => '纬度',])
			->addColumn('altitude', 'string', ['limit' => 10,'null' => true,'signed' => true,'comment' => '海拔',])
			->addColumn('device_no', 'string', ['limit' => 18,'null' => true,'signed' => true,'comment' => '设备号',])
			->addColumn('time', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => true,'signed' => true,'comment' => '定位时间',])
            ->create();
    }
}
