<?php

namespace catchAdmin\transport\controller;

use catcher\base\CatchRequest as Request;
use catcher\CatchResponse;
use catcher\base\CatchController;
use catchAdmin\transport\model\StuckPoint as stuckPointModel;

class StuckPoint extends CatchController
{
    protected $stuckPointModel;
    
    public function __construct(StuckPointModel $stuckPointModel)
    {
        $this->stuckPointModel = $stuckPointModel;
    }
    
    /**
     * 列表
     * @time 2022年11月01日 16:16
     * @param Request $request 
     */
    public function index(Request $request) : \think\Response
    {
        return CatchResponse::paginate($this->stuckPointModel->getList());
    }
    
    /**
     * 列表
     * @time 2022年11月01日 16:16
     * @param Request $request 
     */
    public function getAllList(Request $request) : \think\Response
    {
        return CatchResponse::success($this->stuckPointModel->getAllList());
    }
    /**
     * 保存信息
     * @time 2022年11月01日 16:16
     * @param Request $request 
     */
    public function save(Request $request) : \think\Response
    {
        $params=$request->post();
        // var_dump($params);
        $params['macs']=implode(',',$params['macs']);
        return CatchResponse::success($this->stuckPointModel->storeBy($params));
    }
    
    /**
     * 读取
     * @time 2022年11月01日 16:16
     * @param $id 
     */
    public function read($id) : \think\Response
    {
        return CatchResponse::success($this->stuckPointModel->findBy($id));
    }
    
    /**
     * 更新
     * @time 2022年11月01日 16:16
     * @param Request $request 
     * @param $id
     */
    public function update(Request $request, $id) : \think\Response
    {
        $params=$request->post();
        $params['macs']=implode(',',$params['macs']);
        return CatchResponse::success($this->stuckPointModel->updateBy($id, $params));
    }
    
    /**
     * 删除
     * @time 2022年11月01日 16:16
     * @param $id
     */
    public function delete($id) : \think\Response
    {
        return CatchResponse::success($this->stuckPointModel->deleteBy($id,true));
    }
}