<?php

use think\migration\Migrator;
use think\migration\db\Column;
use Phinx\Db\Adapter\MysqlAdapter;

class StuckSection extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('stuck_section', ['engine' => 'InnoDB', 'collation' => 'utf8mb4_general_ci', 'comment' => '卡点区间' ,'id' => 'id','signed' => true ,'primary_key' => ['id']]);
        $table->addColumn('name', 'string', ['limit' => 128,'null' => true,'signed' => true,'comment' => '名称',])
			->addColumn('pre_spot', 'string', ['limit' => MysqlAdapter::INT_REGULAR,'null' => true,'signed' => true,'comment' => '前置卡点',])
			->addColumn('pos_spot', 'string', ['limit' => MysqlAdapter::INT_REGULAR,'null' => true,'signed' => true,'comment' => '后置卡点',])
			->addColumn('distance', 'string', ['limit' => MysqlAdapter::INT_REGULAR,'null' => true,'signed' => true,'comment' => '区间长度',])
			->addColumn('max_speed', 'string', ['limit' => MysqlAdapter::INT_REGULAR,'null' => true,'signed' => true,'comment' => '最大限速（km/h）',])
			->addColumn('retrograde_stat', 'string', ['limit' => MysqlAdapter::INT_REGULAR,'null' => true,'signed' => true,'comment' => '启用逆行状态',])
			->addColumn('over_speed_stat', 'string', ['limit' => MysqlAdapter::INT_REGULAR,'null' => true,'signed' => true,'comment' => '启用超速状态',])
			->addColumn('creator_id', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '创建人ID',])
			->addColumn('created_at', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '创建时间',])
			->addColumn('updated_at', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '更新时间',])
			->addColumn('deleted_at', 'integer', ['limit' => MysqlAdapter::INT_REGULAR,'null' => false,'default' => 0,'signed' => false,'comment' => '软删除',])
            ->create();
    }
}
